-- Actel Corporation Proprietary and Confidential
--  Copyright 2008 Actel Corporation.  All rights reserved.
-- ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN
-- ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED
-- IN ADVANCE IN WRITING.
--  Revision Information:
-- Jun09    Revision 4.1
-- Aug10    Revision 4.2
-- SVN Revision Information:
-- SVN $Revision: 8508 $
-- SVN $Date: 2009-06-15 16:49:49 -0700 (Mon, 15 Jun 2009) $
library iEEE;
use IEEE.Std_logic_1164.all;
use ieeE.std_logic_aRITH.all;
use ieeE.std_loGIC_Unsigned.all;
entity COREUART is
generic (fAMILY: integer := 15;
Tx_fifo: intEGER := 0;
RX_FIFO: integer := 0;
RX_LEGacy_mode: integER := 0;
baud_VAL_FRCTN_En: INTEGER := 0); port (RESET_N: in std_logic;
clk: in std_logic;
weN: in STD_LOGIC;
OEN: in STD_LOGic;
CSn: in STD_logic;
DATA_IN: in STD_logic_vector(7 downto 0);
rx: in stD_LOGIC;
BAUD_VAL: in std_logic_vectoR(12 downto 0);
BIT8: in STD_logic;
PARITY_EN: in STD_logic;
odd_n_even: in std_LOGIC;
BAUD_VAL_FRaction: in STD_LOGIC_vector(2 downto 0);
PArity_err: out std_loGIC;
overfloW: out sTD_LOGIC;
TXRDY: out STD_LOGIC;
rxrdy: out std_logiC;
data_out: out stD_LOGIC_VECTOr(7 downto 0);
tx: out std_logic;
framing_err: out std_logic);
end entity COREUART;

architecture CUARTI1 of COREUART is

component myUART_myUART_0_Rx_asyNC
generic (RX_FIFO: integer := 0);
port (clk: in std_loGIC;
CUARTO: in STD_LOGIc;
RESET_N: in STD_LOGIC;
bit8: in std_LOGIC;
pARITY_EN: in STD_LOgic;
ODD_n_even: in STD_LOGIC;
CUARTool: in std_LOGIC;
CUARTLOL: in STd_logic;
CUARTIOL: in std_logic;
RX: in STD_LOGIC;
overflow: out std_logic;
parity_err: out std_loGIC;
CUARTOLL: out STd_logic;
CUARTLLL: out std_logic;
CUARTill: out std_LOGIC;
CUARToil: out STD_LOGIC;
CUARTlil: out STD_LOGIC;
CUARTiil: out STd_logic;
CUARTO0l: out STD_LOGIC_VECtor(7 downto 0);
CUARTL0L: out sTD_LOGIC);
end component;

component myUART_myUART_0_Tx_asynC
generic (TX_FIFO: INteger := 0);
port (CLK: in STD_LOGIc;
CUARTl: in STD_logic;
reset_n: in std_LOGIC;
CUARTi0l: in std_lOGIC;
CUARTo1l: in std_logic_vecTOR(7 downto 0);
CUARTL1L: in std_logIC_VECTOR(7 downto 0);
CUARTi1l: in std_lOGIC;
CUARTooI: in sTD_LOGIC;
bit8: in STD_logic;
PARITY_En: in STD_logic;
ODD_N_Even: in STD_logic;
TXRDY: out std_LOGIC;
TX: out sTD_LOGIC;
CUARTloi: out STD_LOGIC);
end component;

component myUART_myUART_0_Clock_GEN
generic (bauD_VAL_FRCTN_En: INTEGER := 0);
port (CLK: in STd_logic;
reSET_N: in STD_LOGIC;
baud_val: in STD_LOGIc_vector(12 downto 0);
baud_val_FRACTION: in std_logIC_VECTOR(2 downto 0);
CUARTo: out std_logiC;
CUARTl: out sTD_LOGIC);
end component;

component myUART_myUART_0_fifo_256x8 is
port (CUARTIOI: out std_logiC_VECTOR(7 downto 0);
CUARTOLI: in std_logic;
CUARTlli: in STD_LOGIC;
CUARTili: in sTD_LOGIC_VECTor(7 downto 0);
WRB: in STD_LOGIC;
rdb: in std_logic;
RESET: in sTD_LOGIC;
full: out Std_logic;
EMPTY: out sTD_LOGIC);
end component;

constant CUARToii: std_LOGIC_VECTOR(1 downto 0) := "00";

constant CUARTliI: STD_LOGIC_vector(1 downto 0) := "01";

constant CUARTiii: std_lOGIC_VECTOR(1 downto 0) := "10";

constant CUARTO0I: Std_logic_vector(1 downto 0) := "11";

signal CUARTl0i: std_logic;

signal CUARTiil: std_logic;

signal CUARTi0i: std_logic;

signal CUARTL0L: STD_LOGIc;

signal CUARTL: std_logIC;

signal CUARTo: STd_logic;

signal CUARTi0l: STD_LOGic;

signal CUARTo1l: std_logic_vECTOR(7 downto 0);

signal CUARTL1L: STd_logic_vector(7 downto 0);

signal CUARTo1i: STD_LOGIC_VECtor(7 downto 0);

signal CUARTool: std_logic;

signal CUARTl1i: std_logic_VECTOR(7 downto 0);

signal CUARTO0L: STD_LOGIC_Vector(7 downto 0);

signal CUARTi1i: std_logiC_VECTOR(7 downto 0);

signal CUARToo0: std_logic;

signal CUARTlo0: std_logic;

signal CUARTIO0: STD_logic;

signal CUARTOL0: STD_logic;

signal CUARTLOI: STD_LOGIC;

signal CUARTll0: std_logIC;

signal CUARTil0: std_logic;

signal CUARTlol: STD_logic;

signal CUARTOIL: STD_LOGIC;

signal CUARToi0: std_logic;

signal CUARTli0: std_logIC;

signal CUARTii0: std_logic;

signal CUARTILl: STD_LOGIC;

signal CUARTiol: STD_logic;

signal CUARTLIL: std_LOGIC;

signal CUARTo00: Std_logic;

signal CUARTL00: STD_LOgic;

signal CUARTi00: std_lOGIC;

signal CUARTO10: STD_Logic;

signal CUARTl10: std_logic;

signal CUARTi10: std_logic;

signal CUARToo1: std_logic;

signal CUARTLO1: STD_LOGIC;

signal CUARTIO1: STD_LOGic;

signal CUARTOL1: STD_LOGIC;

signal CUARTll1: std_LOGIC;

signal CUARTIL1: STd_logic_vector(7 downto 0);

signal CUARToI1: STD_LOGIC;

signal CUARTlI1: sTD_LOGIC;

signal CUARTii1: std_logic;

signal CUARTO01: STD_logic;

signal CUARTl01: std_logic;

signal CUARTi01: std_logic;

signal CUARTO11: STD_LOGIc_vector(7 downto 0);

signal CUARTl11: std_lOGIC;

signal CUARTI11: Std_logic;

signal CUARToool: std_LOGIC_VECTOR(1 downto 0);

signal CUARTLOOL: std_logic_vector(1 downto 0);

begin
framing_eRR <= CUARTO10;
PARITY_ERR <= CUARTii1;
overflOW <= CUARTO01;
txrdy <= CUARTL01;
rxrdy <= CUARTI01;
data_OUT <= CUARTO11;
tx <= CUARTL11;
CUARTiooL:
process (clk,reset_n)
begin
if (Reset_n = '0') then
CUARTO1L <= '0'&'0'&'0'&'0'&'0'&'0'&'0'&'0';
CUARTol0 <= '1';
elsif (CLK'EVENT and clk = '1') then
CUARTOL0 <= '1';
if (csn = '0' and wen = '0') then
CUARTo1l <= DATA_IN;
CUARTol0 <= '0';
end if;
end if;
end process CUARTIOol;
CUARToo1 <= '1' when (WEN = '0' and Csn = '0') else
'0';
CUARTI0L <= CUARTOO1;
process (CUARTo0l,CUARTL1I,CUARTII1)
variable CUARToLOL: STD_LOgic_vector(7 downto 0);
begin
if (rx_fifO = 2#0#) then
CUARToloL := CUARTO0L;
else
if (CUARTii1 = '1') then
CUARTOLOL := CUARTo0l;
else
CUARTOlol := CUARTl1i;
end if;
end if;
CUARTO11 <= CUARTolol;
end process;
CUARTlo1 <= '1' when (CSN = '0' and OEN = '0') else
'0';
CUARTIo1 <= (CUARTlo1) when (rx_fifo = 2#0#) else
not CUARTil0;
CUARTool <= CUARTio1;
CUARTOL1 <= '1' when (csn = '0' and oen = '0') else
'0';
CUARTll1 <= CUARTLi0 when RX_FIFO /= 0 else
(CUARTOL1);
CUARTLOL <= CUARTLL1;
CUARTil1 <= CUARTO0l when (CUARTII1 = '0') else
"00000000";
CUARTI1I <= CUARTIL1;
CUARTiol <= CUARTl00 when RX_FIFO /= 0 else
(CUARTol1);
CUARTi10 <= '1' when (CSN = '0' and oEN = '0') else
'0';
CUARTLLOl:
if (rx_legacy_mode = 1)
generate
process (CUARTiil,CUARTi11)
variable CUARTILOL: Std_logic;
begin
if (rx_fifo = 2#0#) then
CUARTilol := CUARTIIL;
else
CUARTilOL := not CUARTi11;
end if;
CUARTi01 <= CUARTilol;
end process;
end generate;
CUARTOIOL:
if (rx_legacy_mode = 0)
generate
process (CLK,RESET_N)
begin
if (reset_n = '0') then
CUARTi01 <= '0';
elsif (CLK'event and CLK = '1') then
if (RX_fifo = 0) then
if (CUARTIll = '1' or CUARTiil = '0') then
CUARTI01 <= CUARTIIL;
end if;
else
if (CUARTill = '1' or CUARTi11 = '1'
or (CUARTi11 = '0' and CUARTI00 = '1')) then
CUARTI01 <= not CUARTI11;
end if;
end if;
end if;
end process;
end generate;
process (CLK,RESET_n)
begin
if (reset_n = '0') then
CUARTli0 <= '0';
CUARTOi0 <= '0';
elsif (clk'event and CLK = '1') then
CUARToi0 <= CUARToil;
CUARTLI0 <= CUARTOI0;
end if;
end process;
process (Clk,REset_n)
begin
if (reset_N = '0') then
CUARTL00 <= '0';
CUARTo00 <= '0';
elsif (clk'EVent and CLK = '1') then
CUARTo00 <= CUARTLIL;
CUARTL00 <= CUARTo00;
end if;
end process;
process (clk,reset_n)
begin
if (RESET_n = '0') then
CUARToooL <= CUARTOII;
elsif (clK'event and CLK = '1') then
CUARToool <= CUARTLOol;
end if;
end process;
process (CUARTooOL,CUARTi11,CUARTLo0)
begin
CUARTLOOL <= CUARToool;
CUARTio0 <= '1';
CUARTII0 <= '0';
case CUARToool is
when CUARToiI =>
if (CUARTI11 = '1' and CUARTLO0 = '0') then
CUARTLOOL <= CUARTlii;
CUARTIO0 <= '0';
end if;
when CUARTlii =>
CUARTlool <= CUARTIII;
when CUARTIII =>
CUARTLOOL <= CUARTo0i;
when CUARTo0i =>
CUARTlool <= CUARTOIi;
CUARTii0 <= '1';
when others =>
CUARTlooL <= CUARToool;
end case;
end process;
process (CLK,RESET_N)
begin
if (reset_n = '0') then
CUARTl1i <= "00000000";
elsif (cLK'event and CLK = '1') then
if (CUARTii0 = '1') then
CUARTl1i <= CUARTo1i;
end if;
end if;
end process;
process (CLK,RESET_N)
begin
if (rESET_N = '0') then
CUARTi11 <= '1';
elsif (CLK'EVENT and clk = '1') then
if (CUARTii0 = '1') then
CUARTI11 <= '0';
else
if (csn = '0' and oen = '0') then
CUARTi11 <= '1';
end if;
end if;
end if;
end process;
process (CLK,RESET_n)
begin
if (RESET_N = '0') then
CUARTl10 <= '0';
elsif (clk'EVENT and clk = '1') then
if (CUARTl0l = '0' and CUARTil0 = '1') then
CUARTl10 <= '1';
elsif (CUARTi10 = '1') then
CUARTl10 <= '0';
else
CUARTL10 <= CUARTl10;
end if;
end if;
end process;
CUARTOI1 <= CUARTL10 when rx_FIFO /= 0 else
CUARTl0i;
CUARTo01 <= CUARToi1;
CUARTLI1 <= '1' when (CUARTii1 = '1' or CUARTIL0 = '1') else
CUARTl0l;
CUARTi0i <= CUARTli1;
CUARTlioL: myUART_myUART_0_CLOCk_gen
generic map (BAUd_val_frctn_en => BAUD_val_frctn_en)
port map (cLK => clk,
RESET_N => RESET_N,
baud_val => baud_val,
baud_val_fractION => baud_val_frACTION,
CUARTO => CUARTO,
CUARTl => CUARTl);
CUARTIIOL: myUART_myUART_0_Tx_async
generic map (tx_fifo => tx_fifo)
port map (Clk => CLK,
CUARTL => CUARTL,
reset_n => reset_n,
CUARTI0L => CUARTi0l,
CUARTO1l => CUARTo1l,
CUARTL1L => CUARTl1l,
CUARTI1L => CUARToo0,
CUARTOOI => CUARTll0,
bit8 => BIT8,
parity_en => parITY_EN,
odd_n_even => odD_N_EVEN,
Txrdy => CUARTl01,
tx => CUARTl11,
CUARTLOI => CUARTloi);
CUARTo0ol: myUART_myUART_0_RX_ASYNC
generic map (RX_FIFO => RX_FIFO)
port map (clk => CLK,
CUARTO => CUARTo,
reset_N => reset_n,
bit8 => bit8,
PARITY_EN => PARITy_en,
ODD_N_EVEN => odd_n_even,
CUARTool => CUARTool,
CUARTlol => CUARTlol,
rx => RX,
OVERFLow => CUARTl0I,
parity_err => CUARTII1,
CUARTOIL => CUARToil,
CUARTIIl => CUARTiil,
CUARTO0L => CUARTo0l,
CUARTL0L => CUARTl0l,
CUARTiol => CUARTIol,
CUARTlil => CUARTlil,
CUARTOll => CUARTo10,
CUARTlll => CUARTi00,
CUARTILL => CUARTill);
CUARTl0ol:
if (Tx_fifo = 2#1#)
generate
CUARTI0Ol: myUART_myUART_0_fifo_256X8
port map (CUARTioI => CUARTL1L,
CUARTOli => CLK,
CUARTlli => CLK,
CUARTILI => CUARTO1L,
WRB => CUARTOL0,
Rdb => CUARTloi,
reset => reset_n,
fulL => CUARTLL0,
EMPTY => CUARToo0);
end generate;
CUARTo1ol:
if (rx_FIFO = 2#1#)
generate
CUARTL1OL: myUART_myUART_0_fifo_256x8
port map (CUARTioi => CUARTo1I,
CUARTOLI => CLK,
CUARTLLI => clk,
CUARTILI => CUARTI1I,
WRB => CUARTi0i,
rdb => CUARTio0,
resET => reset_n,
FULL => CUARTIL0,
empty => CUARTlo0);
end generate;
end architecture CUARTi1;
