library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;
use IEEE.math_real.all;

library work;
use work.settings.all;

-- Toplevel module of system project
--  * combine all submodules
-- 
-- author: 
-- date:
entity TOP is
  port (
    OSC_CLK     : in  std_logic;                    -- 48 MHz oscillator
    PO_RSTN     : in  std_logic;                    -- asynchronous power on reset (active low)
    PB_RSTN     : in  std_logic;                    -- asynchronous push button reset (active low)
    SWITCH      : in  std_logic_vector(4 downto 0); -- clock divider settings
    LED         : out std_logic_vector(4 downto 0); -- clock divider indication
    VSCALED     : in  std_logic;                    -- PGA output voltage
    VCOMPARE    : in  std_logic;                    -- voltage over capacitor
    VCHARGE     : out std_logic;                    -- charge/discharge capacitor
    TX          : out std_logic;                    -- serial transmission line
    SCK         : out std_logic;                    -- serial clock to PGA
    SDI         : out std_logic;                    -- serial data to PGA
    CSN         : out std_logic);                   -- chip select (low active) to PGA
end entity;
------------------------------------------------------------------------------------------------------------------------