library IEEE;
use IEEE.std_logic_1164.all;

-- Common error messages for various assertions.
-- 
-- author: Andreas Engel
-- data:   03/13
package test is
  procedure test(b    : in boolean;   m : in string);
  procedure test(s, v : in real;      n : in string);
  procedure test(s, v : in std_logic; n : in string);
end package;
------------------------------------------------------------------------------------------------------------------------

package body test is
  procedure test(b : in boolean; m : in string) is
  begin
    assert b 
    report "ERROR @ " & time'image(now) & " : " & m & "."
    severity error;
  end procedure; 

  procedure test(s, v : in real; n : in string) is
  begin
    test(s = v, n & " = " & real'image(s) & ". Expected " & real'image(v));
  end procedure;
  
  procedure test(s, v : in std_logic; n : in string) is
  begin
    test(s = v, n & " = " & std_logic'image(s) & ". Expected " & std_logic'image(v));
  end procedure;
  
end package body;
