`default_nettype none

// Controler of analog to digital converter
//  * on calibration request: perform Vcompare calibration 
//  * on sampling request: increase (decrease) Vcompare if it is smaller (greater) then Vscaled
//  * estimate Vcompare by the sequence of charge and discharge cycles
//  * calculate moving average of Vcompare
//  * confirm end of sampling, if Vcompare crosses its moving average
// 
// author: 
// date:   
module ADC_CONTROL #(`include "settings.v")
 (input  wire                    CLK,           // clock                                          
  input  wire                    RSTN,          // synchronous reset (active low)                 
  input  wire                    COMPARE,       // Vcompare > Vscaled?                            
  input  wire                    CALIBRATE,     // synchronous calibration request (active high)  
  input  wire                    SAMPLE,        // synchronous sampling request (active high)     
  output wire [SAMPLE_WIDTH-1:0] SCALED,        // synchronous sampling confirmation (active high)
  output reg                     DONE,          // sampled value of Vscaled                       
  output reg                     CHARGE);       // Vcompare manipulation signal                   
/**********************************************************************************************************************/