`default_nettype none

// Clock conditioning and reset synchronization
//  * reduce 48 MHz to 4 MHz by static PLL
//  * reduce 4 MHz to 4 MHz / (DIV+1) by a clock divider
//  * generate synchronous resets for both output clocks
// 
// author: 
// date:   
module CLOCK_CONDITIONING
 (input  wire       OSC_CLK,   // 48 MHz oscillator clock
  input  wire       PO_RSTN,   // asynchronous power on reset (active low)
  input  wire       PB_RSTN,   // asynchronous push-button reset (active low)
  input  wire [3:0] DIV,       // clock divider-1
  output wire       LOCK,      // asynchronous PLL lock (active high)
  output wire       CLK,       // 4 MHz clock
  output wire       RSTN,      // synchronous reset (active low) for clk
  output wire       DCLK,      // 4 MHz / (DIV+1) clock
  output wire       DRSTN);    // synchronous reset (active low) for dclk
/**********************************************************************************************************************/  