`default_nettype none

// Comparator selection.
// Set OPAMP_TYPE = 1 to instantiate an LVPECL input buffer
//                 -1 to instantiate an LVDS input buffer
//                  0 to instantiate the combinatorial logic for comparator simulation
// 
// author: Andreas Engel
// date:   03/13
module OPAMP #(`include "settings.v") 
 (input  wire VP,          // positive comparator input 
  input  wire VN,          // negative comparator input 
  output wire O);          // comparator output         
/**********************************************************************************************************************/


generate 
  if      (OPAMP_TYPE > 0) INBUF_LVPECL i_opamp (VP, VN, O);
  else if (OPAMP_TYPE < 0) INBUF_LVDS   i_opamp (VP, VN, O);
  else                     assign O = VP & ~VN;
endgenerate

endmodule