`default_nettype none

// Controller for programmable gain amplifier
//  * transmit saturated gain request to PGA via SPI
//  * normalize sampled value by current gain setting
// 
// author: 
// date:   
module PGA_CONTROL #(`include "settings.v") 
 (input  wire                    CLK,        // 4 MHz clock                   
  input  wire                    RSTN,       // synchronous reset (active low)
  input  wire              [3:0] GAIN,       // asynchronous gain request     
  input  wire [SAMPLE_WIDTH-1:0] SCALED,     // sampled value of Vscaled      
  output wire [SAMPLE_WIDTH+3:0] UNSCALED,   // sampled value of Vin          
  output wire                    SCK,        // SPI clock                     
  output reg                     SDI,        // SPI data                      
  output wire                    CSN);       // SPI chip select (active low)  
/**********************************************************************************************************************/