`default_nettype none

// Static phase-locked loop
//  * derive 4 MHz clock from 48 MHz oscillator
// 
// author: 
// data:   
module PLL48M 
 (input  wire POWERDOWN,     // asynchronous reset (active low)                
  input  wire CLKA,          // 48 MHz oscillator input                        
  output wire LOCK,          // asynchronous output stable signal (active high)
  output wire GLA);          // 4 MHz output clock                             
/**********************************************************************************************************************/

wire w_clka;

PLLINT i_pllint (.A(CLKA), .Y(w_clka));
    
PLL #(32.0) i_pll (
  .CLKA      (w_clka), 
  .EXTFB     (1'b0), 
  .POWERDOWN (POWERDOWN), 
  .GLA       (GLA), 
  .LOCK      (LOCK), 
  .GLB       (), 
  .YB        (), 
  .GLC       (), 
  .YC        (), 
  
  .OADIV0    (1'b1), 
  .OADIV1    (1'b1), 
  .OADIV2    (1'b1), 
  .OADIV3    (1'b0), 
  .OADIV4    (1'b0),
   
  .OAMUX0    (1'b0), 
  .OAMUX1    (1'b0), 
  .OAMUX2    (1'b1), 
  
  .DLYGLA0   (1'b0), 
  .DLYGLA1   (1'b0), 
  .DLYGLA2   (1'b0), 
  .DLYGLA3   (1'b0), 
  .DLYGLA4   (1'b0), 
  
  .OBDIV0    (1'b0), 
  .OBDIV1    (1'b0), 
  .OBDIV2    (1'b0), 
  .OBDIV3    (1'b0), 
  .OBDIV4    (1'b0), 
  
  .OBMUX0    (1'b0), 
  .OBMUX1    (1'b0), 
  .OBMUX2    (1'b0), 
  
  .DLYYB0    (1'b0), 
  .DLYYB1    (1'b0), 
  .DLYYB2    (1'b0), 
  .DLYYB3    (1'b0), 
  .DLYYB4    (1'b0), 
  
  .DLYGLB0   (1'b0), 
  .DLYGLB1   (1'b0), 
  .DLYGLB2   (1'b0), 
  .DLYGLB3   (1'b0), 
  .DLYGLB4   (1'b0), 
  
  .OCDIV0    (1'b0), 
  .OCDIV1    (1'b0), 
  .OCDIV2    (1'b0), 
  .OCDIV3    (1'b0), 
  .OCDIV4    (1'b0), 
  
  .OCMUX0    (1'b0), 
  .OCMUX1    (1'b0), 
  .OCMUX2    (1'b0), 
  
  .DLYYC0    (1'b0), 
  .DLYYC1    (1'b0), 
  .DLYYC2    (1'b0), 
  .DLYYC3    (1'b0), 
  .DLYYC4    (1'b0), 
  
  .DLYGLC0   (1'b0), 
  .DLYGLC1   (1'b0), 
  .DLYGLC2   (1'b0), 
  .DLYGLC3   (1'b0), 
  .DLYGLC4   (1'b0), 
  
  .FINDIV0   (1'b0), 
  .FINDIV1   (1'b0), 
  .FINDIV2   (1'b0), 
  .FINDIV3   (1'b1), 
  .FINDIV4   (1'b0), 
  .FINDIV5   (1'b0), 
  .FINDIV6   (1'b0), 
  
  .FBDIV0    (1'b1), 
  .FBDIV1    (1'b0), 
  .FBDIV2    (1'b1), 
  .FBDIV3    (1'b0), 
  .FBDIV4    (1'b0), 
  .FBDIV5    (1'b0), 
  .FBDIV6    (1'b0), 
  
  .FBDLY0    (1'b0), 
  .FBDLY1    (1'b0), 
  .FBDLY2    (1'b0), 
  .FBDLY3    (1'b0), 
  .FBDLY4    (1'b0), 
  
  .FBSEL0    (1'b1), 
  .FBSEL1    (1'b0), 
  
  .XDLYSEL   (1'b0), 
  
  .VCOSEL0   (1'b1), 
  .VCOSEL1   (1'b1), 
  .VCOSEL2   (1'b0));
    
endmodule 