// Global settings for comparator and system project.

parameter OPAMP_TYPE   =     0,      // 1=LVPECL,-1=LVDS,0=simulation
parameter OPAMP_UPDATE =    15.0,    // [ns]
parameter OPAMP_VFH    =    10.0,    // [mV] falling edge start of switching
parameter OPAMP_VFL    =   -10.0,    // [mV] falling edge end   of switching
parameter OPAMP_VRH    =    10.0,    // [mV] rising  edge end   of switching
parameter OPAMP_VRL    =   -10.0,    // [mV] rising  edge start of switching
parameter VCC          =     3.3,    // [V] maximum of VCOMPARE
parameter VREF         =     1.25,   // [V] reference voltage (center of dynamic input range)
parameter UPDATE_DIV   =     8,      // [1..16] VCHARGE update rate = 4 MHz / UPDATE_DIV
parameter TAU          =   330.0,    // [us] R * C
parameter SAMPLE_WIDTH =     8,      // bits per SCALED sample
parameter RC_ACCURACY  =     4,      // additional accuracy bits of RC model
parameter AVG_SIZE     =     4,      // base for number of averages in RC filter
parameter MAX_GAIN     =    10,      // [1..16] maximum configurable PGA gain
parameter BAUD_RATE    = 14400,      // [baud] serial communication speed
parameter SAMPLE_DIV   =  1100       // sample rate = 4 MHz / UPDATE_DIV / SAMPLE_DIV