// Common error messages for various assertions.
// 
// author: Andreas Engel
// data:   03/13


task testM;
  input b;
  input [8*80-1:0] m;
  if (!b) $display("ERROR @ %f ns: %-0s", $realtime, m);
endtask

task testR;
  input [63:0] s;
  input [63:0] v;
  input [8*80-1:0] n;
  reg   [8*80-1:0] m;
  begin
    $sformat(m, "%-0s = %f. Expected %f", n, $bitstoreal(s), $bitstoreal(v));
    testM(s == v, m);
  end
endtask

task testI;
  input  s;
  input  v;
  input [8*80-1:0] n;
  reg   [8*80-1:0] m;
  begin
    $sformat(m, "%-0s = %d. Expected %d", n, s, v);
    testM(s == v, m);
  end
endtask